/*
 * main.cpp
 *
 *  Created on: Jan 24, 2010
 *      Author: lizier
 */

#include <fstream>
#include <string>
#include <iostream>
#include <vector>
#include <cmath>

using namespace std ;

void usage( ) {

  cout << "Usage: line-length <source> <dest>" << endl ;
  cout << endl ;

  return ;
}

int main( int argc , char* argv[] ) {

  if ( argc != 3 ) {
    usage() ;
    return 1 ;
  }

  ifstream pf( string(string( argv[1] ) + string( ".vtk" )).c_str() ) ;

  if ( pf.is_open() ) {

    string token ;

    pf >> token ;
    while ( token.compare( "POINTS" ) != 0 )
      pf >> token ;

    int npoints ;
    pf >> npoints ;

    pf >> token ;

    vector< double > points ;
    for ( int i = 0 ; i < npoints ; i++ ) {

      double coord ;
      pf >> coord ;
      points.push_back( coord ) ;
      pf >> coord ;
      points.push_back( coord ) ;
      pf >> coord ;
      points.push_back( coord ) ;
    }

    pf >> token ;
    while ( token.compare( "LINES" ) != 0 )
      pf >> token ;

    int nlines ;
    pf >> nlines ;

    int temp ;
    pf >> temp ;

    vector< double > slines ;
    for ( int i = 0 ; i < nlines ; i++ ) {

      slines.push_back( 0 ) ;

      int size ;
      pf >> size ;

      if ( size > 0 ) {

        int anterior ;
        pf >> anterior ;
        for ( int j = 1 ; j < size ; j++ ) {
          int atual ;
          pf >> atual ;

          double distx = points[anterior * 3] - points[atual * 3] ;
          distx *= distx ;
          double disty = points[anterior * 3 + 1] - points[atual * 3 + 1] ;
          disty *= disty ;
          double distz = points[anterior * 3 + 2] - points[atual * 3 + 2] ;
          distz *= distz ;

          double dist = sqrt( distx + disty + distz ) ;

          slines[i] += dist ;

          anterior = atual ;
        }
      }
    }

    pf.close() ;

    ofstream out( string(string( argv[2] ) + string( ".txt" )).c_str() ) ;

    if ( out.is_open() ) {
      for ( unsigned i = 0 ; i < slines.size() ; i++ )
        out << slines[i] << endl ;

      out.close() ;
    } else
      return 1 ;

  } else
    return 1 ;

  cout << "Finished." << endl;

  return 0 ;
}
